  
//////////////////////////////////////////////////////////////////
//Mandelbrot Trapped
/////////////////////////////////////////////////////////////////

ArrayList<Threads> threads;
FarbTafel farben;
double xU = -2; 
double yU = -2; 
double xO = 2;
double yO = 2;
double zoomFaktor=1;
double wh = xO-xU;
double D;
int maxiterations = 256;
double massFuerUnendlich = 20;
int nummerThread;
int anzahlThreads = Runtime.getRuntime().availableProcessors(); 

void setup() {
  background(255);
  noLoop();
  colorMode(RGB);
  threads = new  ArrayList<Threads>(); 
  farben= new FarbTafel();
  farben.farbTafelErzeugen();
  size(1120, 1120);
  
 
  nummerThread =0;
  println("Anzahl Threads: "+anzahlThreads);
  starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  
}

/////////////////////////////////////////////////////////////////

void starteThreads(double px, double py, int pmaxiterations, double pUnendlich, double pwh, int nummer){
  
  xU = px; yU = py;
  nummerThread = nummer;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  wh = pwh;
  double  y= yO-wh/anzahlThreads;
  while(nummerThread <anzahlThreads){
        Threads t = new Threads(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread);
       
        threads.add(t);
        t.start(); 
        nummerThread++;
        y=y-wh/anzahlThreads;
        delay(50);//zur Verringerung der Pixelfehler
   
  }
  
}
//////////////////////////////////////////////////////////////

void draw() {
  
  // die Draw-Methode fügt die PGraphics-Zeichenflächen
  // der Threads zu einem Bild zusammen
  // Warten bis alle Threads fertig sind
 
  for(Threads t: threads){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
  }
  
  for (int i=0; i<threads.size(); i++){
    image(threads.get(i).pg,0,i*height/anzahlThreads);   
  }       
}

/////////////////////////////////////////////////////////////////
void mousePressed() { 
     nummerThread =0;
     threads = new  ArrayList<Threads>(); 
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     // berechne, wo der Mauszeiger im gezeigten Ausschnitt der komplexen
     // Zahlenebene ist (Transformation Pixelposition nach (x,y))
      xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
      xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
      xU = xUNeu; xO = xONeu; 
      
      yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
      yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; 
      yU =yUNeu; yO = yONeu; 
      wh = wh/5;
      zoomFaktor =zoomFaktor*5;
      println("Zoomfaktor: "+zoomFaktor);
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);

     redraw();
}  
/////////////////////////////////////////////////////////////////
void keyPressed() {
  if (key == '+'){
     nummerThread =0;
     background(0);
     maxiterations *= 1.2; println("Iterationsgrenze: "+maxiterations);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  }
  if (key == '-') {
      nummerThread =0;
      background(0);
      maxiterations /= 1.2;println("Iterationsgrenze: "+maxiterations);
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);  
  }
   if (key == 'z'){
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     nummerThread =0;
     background(0);
     xUNeu = xU+0.25*(xO-xU);yUNeu = yU+0.25*(yO-yU);
     xONeu = xO-0.25*(xO-xU);yONeu = yO-0.25*(yO-yU);
     xU = xUNeu;xO = xONeu; 
     yU =yUNeu; yO = yONeu; 
     wh=wh/2;
     zoomFaktor =zoomFaktor*2;
     println("Zoomfaktor: "+zoomFaktor);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  }
  if (key == 'l'){
     nummerThread =0;
     background(0);
     xO = xO + wh/10;
     xU = xU + wh/10;
     println("Verschiebung nach Links");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  }
  if (key == 'r'){
     nummerThread =0;
     background(0);
     xO = xO - wh/10;
     xU = xU - wh/10;
     println("Verschiebung nach Rechts");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  }
   if (key == 'u'){
     nummerThread =0;
     background(0);
     yO = yO + wh/10;
     yU = yU + wh/10;
     println("Verschiebung nach unten");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  }
  if (key == 'o'){
     nummerThread =0;
     background(0);
     yO = yO - wh/10;
     yU = yU - wh/10;
     println("Verschiebung nach oben");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  }
  if (key == 's') save("mandelbrotTrapSinusXYKreise.png");
  redraw();
}
/////////////////////////////////////////////////////////////////
